-- LOSIOC - LOCKON SIOC PAR LECREOLE
-- Export script pour Lock On: Flaming Cliffs 1.12a
--Version du 7_02_2007 20h57
--[[
	- DataListLast modifi
	- Correction Volets A-10 et Su-25
	- Coorection sorties + volets Su-27 et Su-33
	- Correction bug RETAB
	- Lights ready
--]]
-- POUR ACTIVER CE SCRIPT :
--     Mettre [EnableExportScript = true] dans [/Lock On/Config/export/config.lua]
--     Ajouter [dofile("./Config/export/LOSIOC.lua")]  la fin de [/Lock On/Config/export/export.lua]
dofile "lua.lua"
LOSIOC = {
	-- Init variables
	InitOK = false,
	SocketPort = 8091,	-- SocketPort
	PlaneType = 1,		-- Type 1-(Su-25, Su-25T) 2-(MIG-29A, MIG-29S) 3-(Su-27, Su-33) 4-( A-10A) 5-(F-15C)
	MecaState = {},
	DataListLast = {},
	CurSpeedUnit = 1,		-- Mutiplicateur de conversion vitesse
	CurAltUnit = 1,		-- Mutiplicateur de conversion altitude
	Unit = 0,	-- (0-LOCKON 1-US 2-RUSSE)
	BlinkLed = 0,	
	StarLOSIOC = function(self)			-- Liste des commandes ---
		-- Initialisation de la liste des commandes
		self.CommandList = {
	-- Interne
		--[0] = self.SetCommandChangeUnit,		
	-- Elments mcaniques
		[1] = self.SetCommandFlaps,		-- Volets (0-rentrs 1-sortis)
		[2] = self.SetCommandGear,		-- Trains (0-rentrs 1-sortis)
		[3] = self.SetCommandHook,		-- Crochet d'appontage (0-rentrs 1-sortis)
		[4] = function() LoSetCommand(76) end,	-- Sort le parachute
		[5] = self.SetCommandPackWing,		-- Ailes (0-dplies 1-plies)
		[6] = self.SetCommandAirBrake,		-- Arofreins (0-rentrs 1-sortis)
		[7] = self.SetCommandCanopy,		-- Verrire (0-ferme 1-ouverte)
		[8] = self.SetCommandWheelBrake,	-- Freins de roues (0-off 1-on)

	-- Systeme divers
		[9] = self.SetCommandPowerLeft,		-- Mise sous tension moteur gauche(0-off 1-on)
		--[x] = self.SetCommandPowerRight,	-- Mise sous tension moteur droit (0-off 1-on)
		[10] = function() LoSetCommand(144) end,-- Reset master warning
		[11] = self.SetCommandCockpitLight,	-- Allume tableau bord (0-off 1-on)
		[12] = self.SetCommandGearLight,	-- Feu de roue (0-off 1=proche 2-loin 3-proche)
		[13] = self.SetCommandWingLight,	-- Feu ailes
		[14] = self.SetCommandWingtipSmoke,	-- Fumigne (0-off 1-on)
		[15] = self.SetCommandEject,		-- Eject
		--[16] = function() LoSetCommand(288) end,-- Init horloge

	-- System ACS
		--[17] = SetCommandNavigationMode,	-- Mode 1-NAV 2-BVR 3-VS 4-BORE 5-HELMET 6-FIO 7-A2G 8-GRID 9-CANNON
		--[18] = self.SetCommandACSMode,	-- 0-OFF 1-FOLLOW_ROUTE 2-BARO_HOLD 3-RADIO_HOLD 4-BARO_ROLL_HOLD
							-- 5-HORIZON_HOLD 6-PITCH_BANK_HOLD
		--[19] = self.SetCommandAltHold,	-- Altitude Stabilisation (0-off 1-on)
		--[20] = self.SetCommandAutoPilot,	-- Pilote Automatique (0-off 1-on)
		--[21] = self.SetCommandAutoThrust,	-- Manette Automatique (0-off 1-on)

	-- Moteurs et carburant
		[22] = self.SetCommandStarLeftEngine,	-- Dmarrage moteur gauche (0-off 1-on)
		[23] = self.SetCommandStartRightEngine,	-- Dmmarage moteur droit (0-off 1-on)
		[24] = self.SetCommandRefuelingBoom,	-- Ouvre trappe pour fuel
		[25] = self.SetCommandRefuel,		-- Refuel (0-off 1-on)
		[26] = function() LoSetCommand(178) end,-- Jettison containeur fuel (0-off 1-on)

	-- Armement et systemes divers
		[27] = self.SetCommandEcm,		-- Brouillage radar (0=off 1=on)
		--[28] = self.SetCommandRealeaseWeapon,	--
		[29] = self.SetCommandDropSnar,	-- Lache contre mesures 0-Chaff 1-flare 2-chaffetflare 3-Auto
		[30] = self.SetCommandLaserRangeFinder,
		[31] = self.SetCommandNightTV,
		[32] = self.SetCommandChangeRadarPRF,
		[33] = self.SetCommandChangeCannonRate,
		--[34] = function() LoSetCommand(281) end,-- Change ripple quantity
		--[35] = function() LoSetCommand(282) end,-- Change ripple interval
		--[36] = function() LoSetCommand(283) end,-- Switch master arm
		--[37] = function() LoSetCommand(284) end,-- Change realease mode
		--[38] = function() LoSetCommand(101) end,-- Changer arme
	
	-- Radar
		[39] = self.SetCommandRadar,		-- Radar (0-off 1-on)
		[40] = self.SetCommandRotRadarEntenne,	-- Tourne entenne radar (0=neutre 1-gauche 2-droite 3-haut 4-bas 5-init)
		[41] = function() LoSetCommand(262) end,-- Augmente champ radar
		[42] = function() LoSetCommand(263) end,-- Diminue champ radar
		[43] = self.SetCommandChangeRWSMode,	-- Change mode radar 0-RWS 1-TWS
		[44] = self.SetCommandChangeRWRMode,	-- Change mode radar 0-RWR 1-SPO
		[45] = self.SetCommandEOS,		-- EOS (0-off 1-on)

	-- Autres
		[46] = self.SetCommandSalvo,		--
		[47] = self.SetCommandTrim,		-- Compenser (0-neutre 1-gauche 2-droite 3-haut 4-bas 5-init)
		}
		self.InitOK = self.InitConnection(self)
		if self.InitOK then 
			socket.try(SocketLUA:settimeout(0)) 
			-- Initialisation des variables LOSIOC
			self.CurSpeedUnit, self.CurAltUnit = self.SetCurrentUnit(self.Unit)
			self.MecaState = self.GetMecaStateWhenStart(self)
		end
		LOSIOCLog("\tInitialisation = "..tostring(self.InitOK))
	end,

	-- Initialisation de la connection
	InitConnection = function(self)
		LOSIOCLog("Initialisation de la connection:")
		-- Dmarre la connection
		local init = false
		local host = "localhost"
		socket = require("socket")
		-- Tentative de connection
		SocketLUA = socket.connect(host, self.SocketPort)
		if SocketLUA then
			LOSIOCLog("\tConnection = OK")
			socket.try(SocketLUA:setoption("tcp-nodelay",true))
			-- Initialise la liste des variable avec le SIOC
			local SendString = self.ConcatToSIOCInicio(self.CommandList)
			LOSIOCLog("\tEnvoi: "..SendString)
			socket.try(SocketLUA:send(SendString.."\n"))
			-- Attende de rponse
			socket.try(SocketLUA:settimeout(4000))
			data,e= SocketLUA:receive()
			if data == "Arn.Vivo:" then
				LOSIOCLog("\tAttente de rponse Arn.Vivo:[ "..data.."] = OK")
				LOSIOCLog("\tEnvoi: Arn.Vivo:")
				socket.try(SocketLUA:send("Arn.Vivo:\n"))
				data,e= SocketLUA:receive()
				if data ~= nil then
					LOSIOCLog("\tAttente Arn.Resp:[ "..data.."] = OK")
					init=true
				else
					LOSIOCLog("\tAttente Arn.Inicio: = ECHEC")
				end
			else
				LOSIOCLog("\tAttente de rponse Arn.Vivo: = ECHEC")
			end
		else
			LOSIOCLog("\tConnection = ECHEC")
		end
		return init
	end,

	-- Rception des donnes
	ReceptionData = function(self)
		--
		if self.InitOK then
			data, error = SocketLUA:receive()
			if data ~= nil then
				LOSIOCLog("reoit: "..data)
				-- Traitement des donnes reues
				local varSiocNumber
				local varSiocValue
				for v in string.gfind(data,"%w+=%w+") do
					local i = 0
					for d in string.gfind(v,"%w+") do 
						if i==0 then varSiocNumber = tonumber(d) else varSiocValue=tonumber(d) end
						i = i+1
					end
					-- Execution de la commande demande
					if self.CommandList[varSiocNumber] then self.CommandList[varSiocNumber](self, varSiocValue) end
				end
			end
		end
	end,
--[[
	-- Rception des donnes
	ReceptionData = function(self)
		-- 
		if self.InitOK then
			data, error = SocketLUA:receive()
			if data ~= nil then
				LOSIOCLog("reoit: "..data)
				-- Traitement des donnes reues
				for k, v in string.gmatch("1=15:2=56", "(%w+)=(%w+)") do
					LOSIOCLog(k.."="..v)
					if self.CommandList[k] then self.CommandList[k](self,v) end
      				end
			end
		end
	end,
--]]
-- Envoi des donnes
	SendData = function(self)
		local EngineInfo = LoGetEngineInfo()
		local HSIInfo = LoGetControlPanel_HSI()
		local pitch, bank, yaw = LoGetADIPitchBankYaw()
		local SystemeMode = self.LOSIOCGetSystemModeInfo()
		local MCPState = LoGetMCPState()
		local TWSInfo = self.LOSIOCGetTWSInfo()
		local Stations = self.LOSIOCGetPayloadInfo()
		local BlinkLedFlaps = self.BlinkLed==0 and self.MecaState.flaps or math.mod(self.BlinkLed,2)
		self.DataList = {
	-- Info du jeu
		--[x] = self.CurSpeedUnit,			-- Unit de convertion de vitesse (0-m/s 1-noeuds 2-Km/h)
		--[x] = LoGetModelTime(),			-- Temps (sec)
		--[x] = LoGetMissionStartTime(),		-- Temps dbut mission (sec)
	-- Elments mecaniques
		--[x] = self.MecaState.flaps,			-- Volets (0-rentrs 1-Sorties)
		--[x] =  BlinkLedFlaps,				-- Volets (0-rentrs 1-Sorties)
		[94] = self.MecaState.gear,			-- Trains  (0-rentrs 1-Sorties)
		--[x] = self.MecaState.airBrake,		-- Arofreins  (0-rentrs 1-Sorties)
		--[x] = self.MecaState.canopy,			-- Verrire  (0-ferme 1-Ouverte)
		--[x] = self.MecaState.cockpitLight,		-- Lumire cockpit (0-Off 1-On)
		--[x] = self.MecaState.gearLight,		-- Feux de roues (0-Off 1-On)
		--[x] = self.MecaState.wingLight,		-- Feux ailes  (0-Off 1-On)
		--[x] = self.MecaState.wing,
		--[x] = self.MecaState.wheelBrake,
		--[x] = self.MecaState.hook,
		--[x] = self.MecaState.powerLeft,
		--[x] = self.MecaState.powerRight,
		--[x] = self.MecaState.wingTipSmoke,
		--[x] = self.MecaState.refuelReady,
		--[x] = self.MecaState.refuel,
	-- Paramtres avion
		[100] = LoGetAltitudeAboveSeaLevel()*self.CurAltUnit,	-- Altitude niveau mer
		[101] = LoGetAltitudeAboveGroundLevel()*self.CurAltUnit,-- Altitude niveau sol
		[102] = LoGetIndicatedAirSpeed()*self.CurSpeedUnit,	-- IAS (selon unit en cours m/s,noeuds,Km/h)
		[103] = LoGetTrueAirSpeed()*self.CurSpeedUnit,		-- TAS (selon unit en cours m/s,noeuds,Km/h)
		[104] = LoGetAngleOfAttack(),			-- AOA
		[105] = LoGetAccelerationUnits(),		--
		[106] = LoGetVerticalVelocity(),		--
		[107] = LoGetMachNumber(),			-- Mach
		[108] = pitch,					-- pitch
		--[x] = bank,					-- bank
		--[x] = yaw,					-- yaw
		--[x] = 360-LoGetMagneticYaw()*57.3,		-- Cap actuel
		--[x] = LoGetGlideDeviation(),			--
		--[x] = LoGetSideDeviation(),			--
		--[x] = LoGetSlipBallPosition(),		--
		--[x] = LoGetBasicAtmospherePressure(),		--
		--[x] = HSIInfo.ADF,				-- ADF
		--[x] = HSIInfo.RMI,				-- RMI
		--[x] = HSIInfo.Compass,			-- Compass
	-- Infos Electronique
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 		
	-- Infos moteurs
		--[x] = EngineInfo.RPM.left<10 and 1 or 0,		-- Moteur gauche dmarr
		--[x] = EngineInfo.RPM.right<10 and 1 or 0,		-- Moteur droit dmarr
		[130] = EngineInfo.RPM.left,				-- % rgime moteur gauche
		--[x] = EngineInfo.RPM.left>100 and 1 or 0,		-- Post-Combustion moteur gauche
		[131] = EngineInfo.RPM.right,				-- % rgime moteur droit
		--[x] = EngineInfo.RPM.right>100 and 1 or 0,		-- Post-Combustion moteur droit
		--[x] = EngineInfo.Temperature.left,			-- Temprature moteur gauche
		--[x] = EngineInfo.Temperature.right,			-- Temprature moteur droit
		--[x] = EngineInfo.HydraulicPressure.left,		-- Pression Hydraulics gauche
		--[x] = EngineInfo.HydraulicPressure.right,		-- Pression Hydraulics droit
		[136] = EngineInfo.fuel_internal,			-- Quantit fuel interne
		[137] = EngineInfo.fuel_external,			-- Quantit fuel externe
	-- Infos Navigation
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
	-- Infos Systeme ACS
		--[x] = SystemeMode.master,			-- 0-off 1-NAV 2-BVR 3-CAC 4-LNG 5-A2G
		--[x] = SystemeMode.master==1 and 1 or 0,	-- Master mode NAV (0-Off 1-On)
		--[x] = SystemeMode.master==2 and 1 or 0,	-- Master mode BVR (0-Off 1-On)
		--[x] = SystemeMode.master==3 and 1 or 0,	-- Master mode CAC (0-Off 1-On)
		--[x] = SystemeMode.master==4 and 1 or 0,	-- Master mode LNG (0-Off 1-On)
		--[x] = SystemeMode.master==5 and 1 or 0,	-- Master mode A2G (0-Off 1-On)
		--[x] = SystemeMode.submode,			-- 0-OFF 1-ROUTE 2-ARRIVAL 3-LANDING 4-GUN 5-RWS 6-TWS
								-- 7-STT 8-VERTICAL_SCAN 9-BORE 10-HELMET 11-FLOOD
								-- 12-ETS 13-PINPOINT 14-UNGUIDED
		--[x] = SystemeMode.submode==1 and 1 or 0,	-- SubMode ROUTE (0-Off 1-On)
		--[x] = SystemeMode.submode==2  and 1 or 0,	-- SubMode ARRIVAL (0-Off 1-On)
		--[x] = SystemeMode.submode==3  and 1 or 0,	-- SubMode LANDING (0-Off 1-On)
		--[x] = SystemeMode.submode==4  and 1 or 0,	-- SubMode GUN (0-Off 1-On)
		--[x] = SystemeMode.submode==5  and 1 or 0,	-- SubMode RWS (0-Off 1-On)
		--[x] = SystemeMode.submode==6  and 1 or 0,	-- SubMode TWS (0-Off 1-On)
		--[x] = SystemeMode.submode==7  and 1 or 0,	-- SubMode STT (0-Off 1-On)
		--[x] = SystemeMode.submode==8  and 1 or 0,	-- SubMode VERTICAL_SCAN (0-Off 1-On)
		--[x] = SystemeMode.submode==9  and 1 or 0,	-- SubMode BORE (0-Off 1-On)
		--[x] = SystemeMode.submode==10  and 1 or 0,	-- SubMode HELMET (0-Off 1-On)
		--[x] = SystemeMode.submode==11  and 1 or 0,	-- SubMode FLOOD (0-Off 1-On)
		--[x] = SystemeMode.submode==12  and 1 or 0,	-- SubMode ETS (0-Off 1-On)
		--[x] = SystemeMode.submode==13  and 1 or 0,	-- SubMode PINPOINT (0-Off 1-On)
		--[x] = SystemeMode.submode==14  and 1 or 0,	-- SubMode UNGUIDED (0-Off 1-On)
		--[x] = SystemeMode.roll,
		--[x] = SystemeMode.pitch,
		--[x] = SystemeMode.speed,
		--[x] = SystemeMode.vertical_speed,
		--[x] = SystemeMode.altitude,
		--[x] = SystemeMode.ACSMode,			-- 0-OFF 1-FOLLOW_ROUTE 2-BARO_HOLD 3-RADIO_HOLD 4-BARO_ROLL_HOLD
								-- 5-HORIZON_HOLD 6-PITCH_BANK_HOLD
		--[x] = SystemeMode.ACSMode==1 and 1 or 0,	-- ACSMode FOLLOW_ROUTE (0-Off 1-On)
		--[x] = SystemeMode.ACSMode==2 and 1 or 0,	-- ACSMode BARO_HOLD (0-Off 1-On)
		--[x] = SystemeMode.ACSMode==3 and 1 or 0,	-- ACSMode RADIO_HOLD (0-Off 1-On)
		--[x] = SystemeMode.ACSMode==4 and 1 or 0,	-- ACSMode BARO_ROLL_HOLD (0-Off 1-On)
		--[x] = SystemeMode.ACSMode==5 and 1 or 0,	-- ACSMode HORIZON_HOLD (0-Off 1-On)
		--[x] = SystemeMode.ACSMode==6 and 1 or 0,	-- ACSMode PITCH_BANK_HOLD (0-Off 1-On)
		--[x] = SystemeMode.autothrust,			-- Auto-manette
	-- Infos MCP
		--[x] = MCPState.LeftEngineFailure and 1 or 0,		-- Panne Moteur Gauche
		--[x] = MCPState.RightEngineFailure and 1 or 0,		-- Panne Moteur Droit
		--[x] = MCPState.HydraulicsFailure and 1 or 0,		-- Panne Hydrolics
		--[x] = MCPState.ACSFailure and 1 or 0,			-- Panne ACS
		--[x] = MCPState.AutopilotFailure and 1 or 0,		-- Panne pilote automatique
		--[x] = MCPState.AutopilotOn and 1 or 0,		-- Pilote automatique 
		--[x] = MCPState.MasterWarning and 1 or 0,		-- Danger
		--[x] = MCPState.LeftTailPlaneFailure and 1 or 0,	-- 
		--[x] = MCPState.RightTailPlaneFailure and 1 or 0,	-- 
		--[x3] = MCPState.LeftAileronFailure and 1 or 0,	-- 
		--[x] = MCPState.RightAileronFailure and 1 or 0,	-- 
		[171] = MCPState.CanopyOpen and 1 or 0,			-- 
		--[x] = MCPState.CannonFailure and 1 or 0,		-- Panne cannon
		--[x] = MCPState.StallSignalization and 1 or 0,		-- 
		--[x] = MCPState.LeftMainPumpFailure and 1 or 0,	-- 
		--[x] = MCPState.RightMainPumpFailure and 1 or 0,	-- 
		--[x] = MCPState.LeftWingPumpFailure and 1 or 0,	-- 
		--[x] = MCPState.RightWingPumpFailure and 1 or 0,	-- 
		--[x] = MCPState.RadarFailure and 1 or 0,		-- Panne radar
		--[x] = MCPState.EOSFailure and 1 or 0,			-- Panne EOS
		--[x4] = MCPState.MLWSFailure and 1 or 0,		-- Panne MLWS
		--[x] = MCPState.RWSFailure and 1 or 0,			-- Panne RWS
		--[x] = MCPState.ECMFailure and 1 or 0,			-- Panne ECM
		--[x] = MCPState.GearFailure and 1 or 0,		-- Panne Trains
		--[x] = MCPState.MFDFailure and 1 or 0,			-- Panne MFD
		--[x] = MCPState.HUDFailure and 1 or 0,			-- Panne HUB
		--[x] = MCPState.HelmetFailure and 1 or 0,		-- Panne HELMET
		--[x] = MCPState.FuelTankDamage and 1 or 0,		-- Containeur fuel endommag
	-- Infos Radar
		--[x] = TWSInfo.locked,					-- Vrrouiller
		--[x] = TWSInfo.missileAlert,				-- Dpart missile
		--[x] = self.MecaState.ECM,
		--[x] = TWSInfo.mode,
		--[x] = TWSInfo.id,					-- 
		--[x] = TWSInfo.type,
		--[x] = TWSInfo.power,
		--[x] = TWSInfo.azimuth,
		--[x] = TWSInfo.priority,
		--[x] = TWSInfo.signalType,
		--[x] = 
	-- Armments
		--[x] = Stations.CurrentStation,			-- Pylon slectionn
		--[x] = Stations.CountCurWeapon,			-- Qt restante sur le pylon slectionn
		--[x] = Stations.CountTotalCurWeapon,		-- Qt restante totale du meme type d'arme slecctionne
		-- Panel F15-C
		--[x] = Stations.CurWeaponType==44721 and 1 or 0,	-- Arme slectionn est AIM-7
		--[x] = Stations.CurWeaponType==44722 and 1 or 0,	-- Arme slectionn est AIM-9
		--[x] = Stations.CurWeaponType==44724 and 1 or 0,	-- Arme slectionn est AIM-120
		--[x] = Stations[3]==134310 and 1 or 0	,		--fuel tank 1000 gal sur pylon 3
		--[x] = Stations[4]==134310 and 1 or 0	,		--fuel tank 1000 gal sur pylon 4
		--[x] = Stations[11]==134310 and 1 or 0,		--fuel tank 1000 gal sur centre
		
	-- PanelArmement Su33  Ligne 1-Disponibilit ligne 2-Pylons slectionnes
		-- Ligne 1
		--[x] = Stations[1]~=0 and 1 or 0,	--
		--[x] = Stations[3]~=0 and 1 or 0,	--
		--[x] = Stations[5]~=0 and 1 or 0,	--
		--[x] = Stations[7]~=0 and 1 or 0,	--
		--[x] = Stations[9]~=0 and 1 or 0,	--
		--[x] = Stations[11]~=0 and 1 or 0,	--
		--[x] = Stations[12]~=0 and 1 or 0,	--
		--[x] = Stations[10]~=0 and 1 or 0,	--
		--[x] = Stations[8]~=0 and 1 or 0,	--
		--[x] = Stations[6]~=0 and 1 or 0,	--
		--[x] = Stations[4]~=0 and 1 or 0,	--
		--[x] = Stations[2]~=0 and 1 or 0,	--
		-- Ligne 2
		--[x] = Stations[1]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[3]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[5]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[7]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[9]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[11]==Stations.CurWeaponType and 1 or 0,--
		--[x] = Stations[12]==Stations.CurWeaponType and 1 or 0,-- 
		--[x] = Stations[10]==Stations.CurWeaponType and 1 or 0,--
		--[x] = Stations[8]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[6]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[4]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[2]==Stations.CurWeaponType and 1 or 0,	--

	-- PanelArmement SU27 Ligne 1-Disponibilit ligne 2-Pylons slectionnes
		-- Ligne 1
		--[x] = Stations[1]~=0 and 1 or 0,	--
		--[x] = Stations[3]~=0 and 1 or 0,	--
		--[x] = Stations[5]~=0 and 1 or 0,	--
		--[x] = Stations[7]~=0 and 1 or 0,	--
		--[x] = Stations[9]~=0 and 1 or 0,	--
		--[x] = Stations[10]~=0 and 1 or 0,	--
		--[x] = Stations[8]~=0 and 1 or 0,	-- 
		--[x] = Stations[6]~=0 and 1 or 0,	--
		--[x] = Stations[4]~=0 and 1 or 0,	--
		--[x] = Stations[2]~=0 and 1 or 0,	--
		-- Ligne 2
		--[x] = Stations[1]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[3]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[5]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[7]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[9]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[10]==Stations.CurWeaponType and 1 or 0,--
		--[x] = Stations[8]==Stations.CurWeaponType and 1 or 0,	-- 
		--[x] = Stations[6]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[4]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = Stations[2]==Stations.CurWeaponType and 1 or 0,	--
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		--[x] = 
		}
		local SendString = self.ConcatToSIOCResp(self.DataList)
		if SendString ~= "" then
			LOSIOCLog("envoi: "..SendString)
			socket.try(SocketLUA:send(SendString.."\n"))
		end	
	end,

	--
	SetCommandChangeUnit = function(self,v)
		LOSIOC.CurSpeedUnit, LOSIOC.CurAltUnit = LOSIOC.SetCurrentUnit(v)
	end,

	-- Commande des volets
	SetCommandFlaps = function(self,v)
		local _Type = self.PlaneType
		local EngineInfo = LoGetEngineInfo()
		local condition = (EngineInfo.RPM.left>10 or EngineInfo.RPM.right>10) and not LoGetMCPState().HydraulicsFailure
		--LOSIOCLog(tostring(condition))
		if condition then 
			if  v == 0  then
				LoSetCommand(146) 
				self.MecaState.flaps = 0
			else
				if LoGetIndicatedAirSpeed()<136 then
					if v==1 then 
						if _Type == 1 or _Type == 4 then -- Su-25 ou A-10
							LoSetCommand(72) 
						else 
							LoSetCommand(145)
						end						
						self.MecaState.flaps = 1
					else	-- 2me cran v=2
					 	LoSetCommand(145)
						self.MecaState.flaps = 1
					end
				end
			end
		end
	end,

	-- Commande des trains
	SetCommandGear = function(self,v)
		local EngineInfo = LoGetEngineInfo()
		local condition = (EngineInfo.RPM.left>10 or EngineInfo.RPM.right>10) and not LoGetMCPState().HydraulicsFailure
		if condition then 
			if  v == 0  then
				if LoGetAltitudeAboveGroundLevel()>5 then 
					LoSetCommand(430)
					self.MecaState.gear = 0
				end
			else
				if LoGetIndicatedAirSpeed()<136 then
					LoSetCommand(431)
					self.MecaState.gear = 1
					if self.PlaneType==3 then self.MecaState.flaps = 1 end		-- Su-27 et Su-33 sort les volets en meme temps que les trains
					if self.PlaneType==2 then self.MecaState.airBrake = 0 end	-- MiG-29 ferme les AF quand on sort les trains
				end
			end
		end
	end,
	
	-- Commande de la crosse
	SetCommandHook = function(self,v)
		local EngineInfo = LoGetEngineInfo()
		local condition = (EngineInfo.RPM.left>10 or EngineInfo.RPM.right>10) and not LoGetMCPState().HydraulicsFailure
		if condition then
			if self.MecaState.hook ~= v then
				LoSetCommand(69)
				self.MecaState.hook = v
			end
		end
	end,
	
	-- Commande de pliage des ailes
	SetCommandPackWing = function(self,v)
		local EngineInfo = LoGetEngineInfo()
		local condition = (EngineInfo.RPM.left>10 or EngineInfo.RPM.right>10) and not LoGetMCPState().HydraulicsFailure
		if condition then
			if self.MecaState.wing ~= v then
				LoSetCommand(70)
				self.MecaState.wing = v
			end
		end
	end,
	
	-- Commande des arofreins
	SetCommandAirBrake = function(self,v)
		local EngineInfo = LoGetEngineInfo()
		local MCPState = LoGetMCPState()
		local condition = (EngineInfo.RPM.left>10 or EngineInfo.RPM.right>10) and not LoGetMCPState().HydraulicsFailure
		local conditionACS = not MCPState.AutopilotOn and not LoGetNavigationInfo().ACS.autothrust
		if condition and conditionACS then
			local cmd = {[0]=148,[1]=147}
			if self.PlaneType==2 then
				if self.MecaState.gear==0 then
					LoSetCommand(cmd[v])
					self.MecaState.airBrake = v
				end
			else
				LoSetCommand(cmd[v])
				self.MecaState.airBrake = v
			end
		end
	end,

	-- Commande de la verrire
	SetCommandCanopy = function(self,v)
		if self.MecaState.canopy ~= v then
			LoSetCommand(71)
			self.MecaState.canopy = v
		end
	end,
	
		-- Commande des freins de roues 
	SetCommandWheelBrake = function(self,v)
		if self.MecaState.wheelBrake ~= v then
			local cmd = {[0]=75,[1]=74}
			LoSetCommand(cmd[v])
			self.MecaState.wheelBrake = v
		end
	end,
	
	-- Commande de mise sous tension moteur gauche(Su-25)
	SetCommandPowerLeft = function(self,v)
		if self.MecaState.powerLeft ~= v then
			local cmd = {[0]=162,[1]=161}
			LoSetCommand(cmd[v])
			self.MecaState.powerLeft = v
		end
	end,
	
	-- Commande de mise sous tension moteur droit (Su-25)
	SetCommandPowerRight = function(self,v)
		if self.MecaState.powerRight ~= v then
			local cmd = {[0]=164,[1]=163}
			LoSetCommand(cmd[v])
			self.MecaState.powerRight = v
		end
	end,
	
	-- Commande Light cockpit
	SetCommandCockpitLight = function(self,v)
		if self.MecaState.cockpitLight ~= v then
			LoSetCommand(300)
			self.MecaState.cockpitLight = v
		end
	end,

-- Commande des feu trains
	SetCommandGearLight = function(self,v)
		local _num = math.mod((v+4)-self.MecaState.posGearLight,4)
		--LOSIOCLog("valeur voulue = "..v.." valeur actuelle = "..self.MecaState.posGearLight.." resul = ".._num)
		for i=1,_num do
			LoSetCommand(328)
		end
		self.MecaState.posGearLight = v
		if v==0 then self.MecaState.gearLight=0 else self.MecaState.gearLight=1 end
	end,
	
	-- Commande feu ailes
	SetCommandWingLight = function(self,v)
		if self.MecaState.wingLight ~= v then
			LoSetCommand(175)
			self.MecaState.wingLight = v
		end
	end,

	-- Commande des fumignes
	SetCommandWingtipSmoke = function(self,v)
		local condition = LoGetAltitudeAboveGroundLevel()>3
		-- si fumi sur ailes
		if condition then
			if self.MecaState.wingTipSmoke ~= v then
				LoSetCommand(78)
				self.MecaState.wingTipSmoke = v
			end
		end
	end,
		
	-- Commande Eject
	SetCommandEject = function(self,v)
		LoSetCommand(83)
		LoSetCommand(83)
		LoSetCommand(83)
	end,
	
	-- Commande de mode de navigation
	SetCommandNavigationMode = function(self,v)
	
	end,
	
	-- Commande de pilote automatique ACS
	SetCommandACSMode = function(self,v)
	
	end,
	
	-- Command Stabilisation altitude
	SetCommandAltHold = function(self,v)
		local AltHold=-1
		if self.LOSIOCGetSystemModeInfo().ACSMode == 5 then AltHold=1 else AltHold=0 end
		if  AltHold ~= v then
			LoSetCommand(59)
		end
	end,
	
	-- Commande pilote automatique
	SetCommandAutoPilot = function(self,v)
	
	end,
	
	-- Commande auto-manette
	SetCommandAutoThrust = function(self,v)
	
	end,
	
	-- Commande moteur gauche
	SetCommandStarLeftEngine = function(self,v)
		local cmd = {[0]=313,[1]=311}
		LoSetCommand(cmd[v])
	end,
	
	-- Commande moteur droit
	SetCommandStarRightEngine = function(self,v)
		local cmd = {[0]=314,[1]=312}
		LoSetCommand(cmd[v])	
	end,
	
	-- Commande de la perche de ravitaillement
	SetCommandRefuelingBoom = function(self,v)
		if self.MecaState.refuelReady ~= v then
			LoSetCommand(155)
			self.MecaState.refuelReady = v
		end
	end,
	
	-- Commande pour faire le plein de fuel
	SetCommandRefuel = function(self,v)
		local cmd = {[0]=314,[1]=312}
		if self.MecaState.refuel ~= v then
			LoSetCommand(cmd[v])
			self.MecaState.refuel = v
		end
	end,
	
	--
	SetCommandEcm = function(self,v)
	local condition = not LoGetMCPState().ECMFailure
	if condition then
		if self.MecaState.ECM ~= v then
				LoSetCommand(136)
				self.MecaState.ECM = v
			end
		end
	end,
	
	--
	SetCommandRealeaseWeapon = function(self,v)
	
	end,
	
	--
	SetCommandDropSnar = function(self,v)
	
	end,
	
	--
	SetCommandLaserRangeFinder = function(self,v)
	
	end,
	
	--
	SetCommandNightTV = function(self,v)
	
	end,
	
	--
	SetCommandChangeRadarPRF = function(self,v)
	
	end,
	
	--
	SetCommandChangeCannonRate = function(self,v)
	
	end,
	
	--
	SetCommandRadar = function(self,v)
	
	end,
	
	--
	SetCommandRotRadarEntenne = function(self,v)
	
	end,
	
	--
	SetCommandChangeRWSMode = function(self,v)
	
	end,
	
	--
	SetCommandChangeRWRMode = function(self,v)
	
	end,
	
	--
	SetCommandEOS = function(self,v)
	
	end,
	
	--
	SetCommandSalvo = function(self,v)
	
	end,
	
	--
	SetCommandTrim	 = function(self,v)
	
	end,
	
	-- Change l'unit de mesure
	SetCurrentUnit = function(u)
		local speedUnit = {[0]=1, [1]=1.94384449,[2]=3.6}	 -- (1-LOCKON 1-US 2-RUSSE)
		local altUnit = {[0]=1,[1]=3.28,[2]=1}
		return speedUnit[u], altUnit[u]
	end,

	-- Converti une table en language SIOC Arn.Resp
	ConcatToSIOCResp = function(array)
		local result=""
		local k
		local v
		local c=1
		for k,v in pairs(array) do
			local value = string.format("%.0f",v)
			if value ~= LOSIOC.DataListLast[k] then
				LOSIOC.DataListLast[k] = value
				result = result..k.."="..value..":"
				c = c + 1
			end
			
			--if c>= 100 then break end
		end
		if result~="" then result="Arn.Resp:"..result end
		return result
	end,

	-- Converti une table en langaga SIOC Arn.Inicio
	ConcatToSIOCInicio = function(array)
		local result=""
		for k,v in pairs(array) do
			result = result..k..":"
		end
		result="Arn.Inicio:"..result
		return result
	end,
	-- Rcupre l'tats des lments mcaniques au debut du jeu (Piste jour)
	GetMecaStateWhenStart = function(self)
		local _Type = {Su25=1, MiG2=2, Su27=3, Su33=3, A10A=4, F15C=5}
		local plane = string.gsub(string.sub(LoGetObjectById(LoGetPlayerPlaneId()).Name,1,5),"-","")
		self.PlaneType = _Type[plane]
		local _flaps, _gear, _canopy, _powerLeft, _powerRight = 0, 0, 0, 0, 0
		local atAir = LoGetAltitudeAboveGroundLevel()>3 -- and true or false	-- Dfinit si l'avion est en vol
		local engineStop = LoGetEngineInfo().RPM.left<1 -- and true or false	-- Dfinit si le moteur est dmarrer
		local startTime =  LoGetMissionStartTime()
		if atAir then
			-- Start en vol
			--_gear=0
			--_canopy=0
			--_flaps=0
			_powerLeft=1
			_powerRight=1
		elseif engineStop then 
			-- Start parking
			_gear=1
			_canopy=1
			--_flaps=0
		else
			-- Start piste
			_powerLeft=1
			_powerRight=1
			_gear=1
			--_canopy=0
			if self.PlaneType == 1 then _flaps=1 else _flaps=0 end
		end
			return {flaps=_flaps, gear=_gear, hook=0, wing=0, canopy=_canopy, wheelBrake=0, wingTipSmoke=0,
			 	airBrake=0, cockpitLight=0, wingLight=0, posGearLight=0, gearLight=0, powerLeft=_powerLeft, powerRight=_powerRight, refuelReady=0,
			 	refuel=0, ECM=0}	
	end,

	--
	LOSIOCGetSystemModeInfo = function()
		local NavigationInfo = LoGetNavigationInfo()
		local SystemMode = NavigationInfo.SystemMode
		local SystemRequirements =  NavigationInfo.Requirements
		local MasterModes = {OFF=0, NAV=1, BVR=2, CAC=3, LNG=4, A2G=5}
		local Submodes = {OFF=0, ROUTE=1, ARRIVAL=2, LANDING=3, GUN=4, RWS=5, TWS=6, STT=7, 
				VERTICAL_SCAN=8, BORE=9, HELMET=10, FLOOD=11, ETS=12, PINPOINT=13, UNGUIDED=14}
		local ACSModes = {OFF=0, FOLLOW8ROUTE=1, BARO_HOLD=2, RADIO_HOLD=3, BARO_ROLL_HOLD=4, HORIZON_HOLD=5,
				PITCH_BANK_HOLD=6}
		 
		return {master = MasterModes[SystemMode.master],
			submode = Submodes[SystemMode.submode],
			roll = SystemRequirements.roll,
			pitch = SystemRequirements.pitch,
			speed = SystemRequirements.speed,
			vertical_speed = SystemRequirements.vertical_speed,
			altitude = SystemRequirements.altitude,
			ACSMode = ACSModes[NavigationInfo.ACS.mode],
			autothrust = NavigationInfo.ACS.autothrust and 1 or 0
		}	
	end,

	--
	LOSIOCGetTWSInfo = function()
		local TWSInfo = LoGetTWSInfo()
		local _id = {} 
		local _signalType = {}
		local _alert = 0
		local _lock = 0
		local Emitters = {scan=0, lock=1, missile_radio_guided=2, track_while_scan=3}
		for i, cur in pairs(TWSInfo.Emitters) do
			_id[0] = cur.ID
			_signalType[0] = cur.SignalType
			if cur.SignalType == "missile_radio_guided" then _alert = 1 end
			if cur.SignalType == "lock" then _lock = 1 end
		end
		return {	mode = TWSInfo.Mode,
			id =_id[0],
			--type = TWSInfo.Emitters.Type,
			--power = TWSInfo.Emitters.Power,
			--azimuth = TWSInfo.Emitters.Azimuth,
			--priority = TWSInfo.Emitters.Priority,
			signalType = Emitters[_signalType[0]],
			missileAlert = _alert,
			locked = _lock
		}
	end,

	-- 
	LOSIOCGetPayloadInfo = function()
		local Stations = LoGetPayloadInfo()
		local CurrentStation = 0
		local CurWeaponType = -1
		local CountCurWeapon = 0
		local CountCurTotalWeapon = 0
		local Weapons = {}
		-- initialise les pylons  0(vide)
		for i = 1,12 do
			Weapons[i]=0
		end

		if Stations then
			local WeaponSelected=0
			CurrentStation = Stations.CurrentStation
			if CurrentStation ~= 0 then
			 	WeaponSelected = Stations.Stations[CurrentStation].weapon
				CurWeaponType = tonumber(WeaponSelected.level1..WeaponSelected.level2..WeaponSelected.level3..WeaponSelected.level4)
				--if CurWeaponType==0 then CurWeaponType=-1 end
			end
			for i_st,st in pairs(Stations.Stations) do
				if st.count~=0 then Weapons[ i_st]=tonumber(st.weapon.level1..st.weapon.level2..st.weapon.level3..st.weapon.level4) end	
				if  CurrentStation == i_st then  CountCurWeapon = st.count end
				if Weapons[ i_st]==CurWeaponType then CountCurTotalWeapon=CountCurTotalWeapon+st.count end
			end
		end
		--LOSIOCLog(CurrentStation)
		return {	CurrentStation = CurrentStation,
			CountCurWeapon 	= CountCurWeapon,
			CountTotalCurWeapon = CountCurTotalWeapon,
			CurWeaponType = CurWeaponType,
			[1] = Weapons[1],
			[2] = Weapons[2],	
			[3] = Weapons[3],	
			[4] = Weapons[4],	
			[5] = Weapons[5],	
			[6] = Weapons[6],	
			[7] = Weapons[7],	
			[8] = Weapons[8],	
			[9] = Weapons[9],	
			[10] = Weapons[10],	
			[11] = Weapons[11],	
			[12] = Weapons[12]
		}

	end
}
-- Cration de coroutines pour LOSIOC
Coroutines = {}	-- Tables des coroutines

function CoroutineResume(index, tCurrent)
	coroutine.resume(Coroutines[index], tCurrent)
	return coroutine.status(Coroutines[index]) ~= "dead"
end

-- 
function LOSIOCModelTimer(t)
	local tNext = t
	LOSIOC:StarLOSIOC()
	while LOSIOC.InitOK do
		if LoGetPlayerPlaneId() then
			LOSIOC:ReceptionData()
			LOSIOC:SendData()
		end
		tNext = coroutine.yield()
	end
end

-- 
function SetBlinkLed(t)
	local tNext = t
	while LOSIOC.BlinkLed > 0 do
		LOSIOCLog("Blink")
		LOSIOC.BlinkLed = LOSIOC.BlinkLed-1	
		tNext =  coroutine.yield()
	end
end

-- Dclaration des coroutines
Coroutines[1] = coroutine.create(LOSIOCModelTimer)
Coroutines[2] = coroutine.create(SetBlinkLed) 

-- Dmarre la coroutine LOSIOCModelTimer avec un timer de 5/100 secondes
LoCreateCoroutineActivity(1, 0, 0.1)
--LoCreateCoroutineActivity(2, 0, 0.25)

function LOSIOCLog(s)
logText = s.."\n"
	io.write(logText)
end
--[[
	LOSIOC:StarLOSIOC()
	LOSIOC:ReceptionData()
	LOSIOC:SendData()
--]]
